﻿public class BiggerBiofuelTanks : Mod
{
    private HarmonyLib.Harmony harmony;
    private static string modId = "hu.moli.raftmod.biggerbiofueltanks";
    public void Start()
    {
        harmony = new HarmonyLib.Harmony(modId);
        harmony.PatchAll();
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(modId);
    }
    [HarmonyLib.HarmonyPatch(typeof(Tank), "NormalizedTankAmount", HarmonyLib.MethodType.Getter)]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_Tank_NormalizedTankAmount
    {
        static void Prefix(ref Tank __instance, ref FuelValue_FiltrationType ___tankFiltrationType, ref float ___maxCapacity)
        {
            if ((___tankFiltrationType == FuelValue_FiltrationType.FV_FUELTANK || __instance.name == "BiofuelOutputTank") && ___maxCapacity < 2000)
            {
                ___maxCapacity *= 10;
            }
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Tank), "SetTankAmount", new System.Type[] { typeof(float) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_Tank_SetTankAmount
    {
        static void Prefix(ref Tank __instance, ref FuelValue_FiltrationType ___tankFiltrationType, ref float ___maxCapacity, ref float newAmount)
        {
            if ((___tankFiltrationType == FuelValue_FiltrationType.FV_FUELTANK || __instance.name == "BiofuelOutputTank") && ___maxCapacity < 2000)
            {
                ___maxCapacity *= 10;
            }
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Tank), "TempUpdateText")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_Tank_TempUpdateText
    {
        static void Prefix(ref Tank __instance, ref FuelValue_FiltrationType ___tankFiltrationType, ref float ___maxCapacity)
        {
            if ((___tankFiltrationType == FuelValue_FiltrationType.FV_FUELTANK || __instance.name == "BiofuelOutputTank") && ___maxCapacity < 2000)
            {
                ___maxCapacity *= 10;
            }
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Tank), "ModifyTank", new System.Type[] { typeof(Network_Player), typeof(float), typeof(Item_Base) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_Tank_ModifyTank
    {
        static void Prefix(ref Tank __instance, ref FuelValue_FiltrationType ___tankFiltrationType, ref float ___maxCapacity, ref Network_Player player, ref float amount, ref Item_Base itemType)
        {
            if ((___tankFiltrationType == FuelValue_FiltrationType.FV_FUELTANK || __instance.name == "BiofuelOutputTank") && ___maxCapacity < 2000)
            {
                ___maxCapacity *= 10;
            }
        }
    }
}
